#!/bin/sh
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# 2002 QAcafe http://qacafe.com
#
# $Id: simple-vrrp.tcl,v 1.2 2002/06/13 18:39:53 joe Exp $
#
#
# simple VRRP example
#

 
# The next line execs tclsh \
exec tclsh "$0" "$@"

# -- include pktsrc
package require pktsrc

# -- open a packet source interface
set port1 [ pktsrc open eth0 ] 

# -- set my IP address on this interface (should be unused address)
set host 192.168.1.25
set vaddr 192.168.1.200
set vrid 1

# -- place filters on the packet source to only receive my packets (or arp)
$port1 filter "arp or host $host or host $vaddr or proto 112"

# -- now create the stack
Stack_init stack1 $port1 $host 255.255.255.0
 
# -- name each stack to improve logging
Stack_name stack1 vrrpexample

# -- uncomment if you want to see dumps of all the packets
set stack1(print) on

# -- turn on timestamps
set stack1(timestamp) on

# -- turn on packet dump at the hex level
$port1 dump on

# -- add default route
IPv4_set stack1 default 192.168.1.100
Event_wait 1000

#
# send a VRRP advertisement
#
# vrid      1
# priority  101
# address   vaddr

#
# -- simple implementation of VRRP
#

while { 1 } {

   # -- send advert every second
   VRRP_send_advert stack1 $vrid 101 $vaddr
   Event_wait 1000

}

# -- not reached
vwait forever







