#!/bin/sh
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# 2001 QAcafe http://qacafe.com
#
# $Id: sniffer.tcl,v 1.2 2002/02/26 23:40:19 joe Exp $
#
#
# The next line execs tclsh \
exec tclsh "$0" "$@"

# 
# Sniffer example
#

# -- include pktsrc
package require pktsrc

set options(interface) eth0
set options(filter) ""

#
# -- parse command line options
#

for { set i 0 } { $i < $argc } { incr i } {

  set arg [lindex $argv $i]

    switch -- $arg \
       "-interface" {
           incr i
           set options(interface) "[lindex $argv $i]"
           continue

       } "-i" {
           incr i
           set options(interface) "[lindex $argv $i]"
           continue

       } "-filter" {
           incr i
           set options(filter) "[lindex $argv $i]"
           continue

       }  default {
           puts "Unknown switch \"$arg\""
           exit
       }

    break
}

set port1 [ pktsrc open $options(interface) ] 
$port1 filter "$options(filter)"

# -- create stack
Stack_init stack1 $port1 192.168.1.15 255.255.255.0
 
# -- name each stack to improve logging
Stack_name stack1 sniffer

# -- uncomment if you want to see dumps of all the packets
set stack1(print) on
set stack1(snifferMode) on

# -- turn on packet dump at the hex level
$port1 dump on

# -- just loop forever
vwait forever


