#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# 2001 QAcafe http://qacafe.com
#
# $Id: tk-example.tcl,v 1.2 2001/03/07 16:49:37 joe Exp $
#
#!/bin/sh
#
# The next line execs tclsh \
exec wish "$0" "$@"

# -- include pktsrc
package require pktsrc 1.1

#
# tk example
#
# This is an example of using pktsrc with tcltk to build a simple GUI.
# This is a simple packet generator.
# 
# - build an ip packet
# - display packet fields in text box
# - build/send the packet when send button is pressed


# -- this is the base packet

set dstmac  "002122322322"
set srcmac  "000000010203"
set proto   "0800"
set header  "45"
set tos     "08"
set ip      "002ea5ea00003e"
set ipproto "11"
set cksum   "d2d2"
set ip_src  "3.1.1.1"
set ip_dst  "4.1.1.1"
set udp     "00010001001a0000"
set size    128

set handle [ pktsrc open eth0 ]

# -- helper proc for adding fields

proc add_field { str name width } {
   label .label$name -text $str
   entry .entry$name -width $width -relief sunken -bd 2 -textvariable $name
   grid .label$name .entry$name
   grid .label$name -sticky w -padx 3
   grid .entry$name -sticky w -pady 2

}

add_field "Des MAC" dstmac 12
add_field "Src MAC" srcmac 12
add_field "Proto" proto 4
add_field "IP ver/len" header 2
add_field "TOS" tos 2
add_field "Body" ip 14

# -- hmm this is display as hex, should it be decimal ?
add_field "IP Proto" ipproto 2

add_field "IP src" ip_src 13
add_field "IP dst" ip_dst 13
add_field "size" size 4


# -- handle to build and send the packet
button .send -text "Send" -command {
   global handle
   global dstmac srcmac proto header tos ip ip_src ip_dst udp
   global size ipproto cksum

   set src [ iptohex $ip_src ]
   set dst [ iptohex $ip_dst ]

   # -- build the packet
   set packet [ format "%s%s%s%s%s%s%s%s%s%s%s" \
      $dstmac $srcmac $proto $header $tos $ip $ipproto $cksum $src $dst $udp ]

   $handle send-ip $packet $size
}

grid .send -padx 1m -pady 2m












