#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# 2001 QAcafe http://qacafe.com
#
# $Id: log.tcl,v 1.7 2002/11/15 13:23:54 joe Exp $
#
#
# Logging support
#
# ----------------------------------------------------------------------------

# -- this is part of the pktsrc package
package provide pktsrc 1.3

global _running_time 0

proc pktsrcLog { message } {
   set time [clock format [ clock seconds ] -format "%H:%M:%S"]
   puts "INFO: $time| $message"
} 

proc pktsrcInfo { stack message } {
   upvar $stack s

   if { "$s(log)" == "on" } {

     if [ info exists s(timestamp) ] {
        set time [clock format [ clock seconds ] -format "%H:%M:%S"]
        puts "INFO($s(name)): $time| $message"
     } else {
        puts "INFO($s(name)): $message"
     }

     flush stdout
  }
} 

proc pktsrcTrace { stack message } {
   upvar $stack s

   if { "$s(log)" == "on" } {

      if [ info exists s(trace) ] {
         if [ info exists s(timestamp) ] {
            set time [clock format [ clock seconds ] -format "%H:%M:%S"]
            puts "TRACE($s(name)): $time| $message"
         } else {
            puts "TRACE($s(name)): $message"
         }
      }
      flush stdout
   }
} 

proc pktsrcWarn { stack message } {
   upvar $stack s

   if [ info exists s(timestamp) ] {
     set time [clock format [ clock seconds ] -format "%H:%M:%S"]
      puts "WARNING($s(name)): $time| $message"
   } else {
      puts "WARNING($s(name)): $message"
   }

   flush stdout
} 











