/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  http://qacafe.com
 *
 *  $Id: tclPktSrc.h,v 1.1.1.1 2001/03/07 16:35:47 joe Exp $
 *
 */

#ifndef _tclpktsrc_h_
#define _tclpktsrc_h_

#include "tcl.h"
#include "pcap.h"

/*
 * The PktSrc typedef is a data structure that defines one instance
 * of the widget.  There might be many instances in one interface.
 */



typedef struct {
	Tcl_Interp *interp;	/* The interpreter of the widget */
	
        int fd;           
        pcap_t *pd;
        char *read_script;

        char name[16];          /* the Tcl command instance name */
        char connState[5];      /* up or down */

        char *device;           /* physical device name */
        char *filter;           /* libpcap style filter in use */
 
        int writeErrors;

        int packetsOut;
        int packetsIn;
        int lastOutSize;

        int dump;
} PktSrc;


/*
 * Helper functions
 */

char * PktSrc_makeAscii( unsigned char *packet, int length);
char * ascii_to_hex_packet( Tcl_Interp *interp, unsigned char *ascii, int *length );


#endif





